/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the ConnectionResult type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ConnectionResult{}

// ConnectionResult struct for ConnectionResult
type ConnectionResult struct {
	Config []interface{} `json:"config,omitempty"`
	Result []interface{} `json:"result,omitempty"`
}

// NewConnectionResult instantiates a new ConnectionResult object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewConnectionResult() *ConnectionResult {
	this := ConnectionResult{}
	return &this
}

// NewConnectionResultWithDefaults instantiates a new ConnectionResult object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewConnectionResultWithDefaults() *ConnectionResult {
	this := ConnectionResult{}
	return &this
}

// GetConfig returns the Config field value if set, zero value otherwise.
func (o *ConnectionResult) GetConfig() []interface{} {
	if o == nil || IsNil(o.Config) {
		var ret []interface{}
		return ret
	}
	return o.Config
}

// GetConfigOk returns a tuple with the Config field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConnectionResult) GetConfigOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Config) {
		return nil, false
	}
	return o.Config, true
}

// HasConfig returns a boolean if a field has been set.
func (o *ConnectionResult) HasConfig() bool {
	if o != nil && !IsNil(o.Config) {
		return true
	}

	return false
}

// SetConfig gets a reference to the given []interface{} and assigns it to the Config field.
func (o *ConnectionResult) SetConfig(v []interface{}) {
	o.Config = v
}

// GetResult returns the Result field value if set, zero value otherwise.
func (o *ConnectionResult) GetResult() []interface{} {
	if o == nil || IsNil(o.Result) {
		var ret []interface{}
		return ret
	}
	return o.Result
}

// GetResultOk returns a tuple with the Result field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConnectionResult) GetResultOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Result) {
		return nil, false
	}
	return o.Result, true
}

// HasResult returns a boolean if a field has been set.
func (o *ConnectionResult) HasResult() bool {
	if o != nil && !IsNil(o.Result) {
		return true
	}

	return false
}

// SetResult gets a reference to the given []interface{} and assigns it to the Result field.
func (o *ConnectionResult) SetResult(v []interface{}) {
	o.Result = v
}

func (o ConnectionResult) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ConnectionResult) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Config) {
		toSerialize["config"] = o.Config
	}
	if !IsNil(o.Result) {
		toSerialize["result"] = o.Result
	}
	return toSerialize, nil
}

type NullableConnectionResult struct {
	value *ConnectionResult
	isSet bool
}

func (v NullableConnectionResult) Get() *ConnectionResult {
	return v.value
}

func (v *NullableConnectionResult) Set(val *ConnectionResult) {
	v.value = val
	v.isSet = true
}

func (v NullableConnectionResult) IsSet() bool {
	return v.isSet
}

func (v *NullableConnectionResult) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableConnectionResult(val *ConnectionResult) *NullableConnectionResult {
	return &NullableConnectionResult{value: val, isSet: true}
}

func (v NullableConnectionResult) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableConnectionResult) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
